#include<iostream>
#include<math.h>
#include<stdlib.h>
#include<fstream>
#include<sstream>
#include<vector> 
#include <unistd.h>
#include<ctime>
using namespace std;

int InitialConfg=0;

int bond1=2;
int ang1=3;
int c=1;
int nb=1;
int na=1;

const int npolymax=1000;
const int nbeadsmax=2048;

int bond[npolymax*nbeadsmax][2];
int angle[npolymax*nbeadsmax][3];
double position[npolymax][nbeadsmax][3];

int reps;
int nbond=0;
int nangle=0;


int main(int argc, char* argv[]){

cout << "Input argv: argv[1]:L argv[2]:npoly1; argv[3]=nbeads1; argv[4]=npoly2; argv[5]=nbeads2;"<<endl;
srand(time(NULL));

int npoly1,nbeads1,ntype1,npoly2,nbeads2,ntype2;
double L=atof(argv[1]); 
npoly1=atoi(argv[2]);
nbeads1=atoi(argv[3]);
npoly2=atoi(argv[4]);
nbeads2=atoi(argv[5]);
ntype1=1;
ntype2=1;
	
ofstream writeW;
stringstream writeFileW;
writeFileW << "Polys.l"<<L<<"n"<<npoly1<<"m"<<nbeads1<<"t"<<ntype1<<"n"<<npoly2<<"m"<<nbeads2<<"t"<<ntype2;
writeW.open(writeFileW.str().c_str());
    
///////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////
for(reps=0;reps<npoly1;reps++){
//sleep(0.5);
cout << "Poly1: " << reps <<endl;

//////////////////////////////////////////////////////////////
////////		MAKE POLYMER 1    /////////////////////
//////////////////////////////////////////////////////////////
cout << "BONDS" <<endl;
int cumulative=0;
for(int rr=0;rr<reps;rr++)cumulative+=nbeads1;
int nbeadT=0;
for(int i=0;i<nbeads1-1;i++){
    nbeadT++;
    //cout << " if " <<endl;
    bond[nbond][0] = i+cumulative;
    bond[nbond][1] = i+1+cumulative;
    nbond++;
    //cout << nbond << " " << i << endl;
}
    
cout << "ANGLES" <<endl;
for(int i=0;i<nbeads1-2;i++){
    angle[nangle][0] = i+cumulative;
    angle[nangle][1] = i+1+cumulative;
    angle[nangle][2] = i+2+cumulative;
    nangle++;
}

///////////////////////////////////////////////////////////
//make polymer
double theta[2];
double phi[2];
double non1=((double)(rand())/((double)(RAND_MAX)));
double non=((double)(rand())/((double)(RAND_MAX)));
///////////////////////////////////////////////////////////

double zshift;
double yshift;
double xshift;
for(int m=0;m<nbeads1;m++){
if(m==0){
position[reps][m][0]=((double)(rand())/((double)(RAND_MAX)))*L-L/2.;
position[reps][m][1]=((double)(rand())/((double)(RAND_MAX)))*L-L/2.;
position[reps][m][2]=((double)(rand())/((double)(RAND_MAX)))*L-L/2.;
}
else{
position[reps][m][0]=position[reps][m-1][0]+0.9*(((double)(rand())/((double)(RAND_MAX)))*2-1);
position[reps][m][1]=position[reps][m-1][1]+0.9*(((double)(rand())/((double)(RAND_MAX)))*2-1);
position[reps][m][2]=position[reps][m-1][2]+0.9*(((double)(rand())/((double)(RAND_MAX)))*2-1);
}
    
}
cout << "DONE polymer "<<reps << endl;
} //close loop over reps

		
//////////////////////////////////////////////////////////////
////////		MAKE POLYMERS 2    /////////////////////
//////////////////////////////////////////////////////////////

int ntotbeads1=npoly1*nbeads1;
	
for(reps=0;reps<npoly2;reps++){
//sleep(0.5);
cout << "Poly2: " << reps <<endl;

cout << "BONDS" <<endl;
int cumulative=0;
cumulative+=ntotbeads1;
for(int rr=0;rr<reps;rr++)cumulative+=nbeads2;
int nbeadT=0;
for(int i=0;i<nbeads2-1;i++){
    nbeadT++;
    //cout << " if " <<endl;
    bond[nbond][0] = i+cumulative;
    bond[nbond][1] = i+1+cumulative;
    nbond++;
    //cout << nbond << " " << i << endl;
}
    
cout << "ANGLES" <<endl;
for(int i=0;i<nbeads2-2;i++){
    angle[nangle][0] = i+cumulative;
    angle[nangle][1] = i+1+cumulative;
    angle[nangle][2] = i+2+cumulative;
    nangle++;
}

///////////////////////////////////////////////////////////
//make polymer
double theta[2];
double phi[2];
double non1=((double)(rand())/((double)(RAND_MAX)));
double non=((double)(rand())/((double)(RAND_MAX)));
///////////////////////////////////////////////////////////

double zshift;
double yshift;
double xshift;
for(int m=0;m<nbeads1;m++){
if(m==0){
position[reps][m][0]=((double)(rand())/((double)(RAND_MAX)))*L-L/2.;
position[reps][m][1]=((double)(rand())/((double)(RAND_MAX)))*L-L/2.;
position[reps][m][2]=((double)(rand())/((double)(RAND_MAX)))*L-L/2.;
}
else{
position[reps][m][0]=position[reps][m-1][0]+0.9*(((double)(rand())/((double)(RAND_MAX)))*2-1);
position[reps][m][1]=position[reps][m-1][1]+0.9*(((double)(rand())/((double)(RAND_MAX)))*2-1);
position[reps][m][2]=position[reps][m-1][2]+0.9*(((double)(rand())/((double)(RAND_MAX)))*2-1);
}
    
}
cout << "DONE polymer "<<reps << endl;
} //close loop over reps

////////////////////////////////////////////////////
////////		WRITE FILE     /////////////////////
////////////////////////////////////////////////////
int totb=npoly1*nbeads1+npoly2*nbeads2;
writeW<< "LAMMPS data file from restart file: timestep = 0,\t procs = 1"<<endl;
writeW << totb << " atoms "<<endl;
writeW << nbond << " bonds "<<endl;
writeW << nangle << " angles "<<endl;
writeW << "\n";
writeW << ntype1+ntype2+1 << " atom types "<<endl;
writeW << 1 << " bond types "<<endl;
writeW << 1 << " angle types "<<endl;
writeW << "\n";
writeW << -L/2.0 << " " << (L-L/2.0) << " xlo xhi"<<endl;
writeW << -L/2.0 << " " << (L-L/2.0) << " ylo yhi"<<endl;
writeW << -L/2.0 << " " << (L-L/2.0) << " zlo zhi"<<endl;
//
////////////////////////////////////////////////////
////////		WRITE FILE     /////////////////////
////////////////////////////////////////////////////
//writeW<< "LAMMPS data file from restart file: timestep = 0,\t procs = 1"<<endl;
//writeW << "\n";
//writeW << "\n";
//

writeW << "\nMasses \n"<<endl;
for(int i=1; i<=ntype1+ntype2+1; i++) writeW << i << " " << 1 << endl;
 //
int cc1=1;
int cc2=1;
// cc goes through the number of atoms
writeW << "\nAtoms \n"<<endl;
    for(int nn=0; nn<npoly1; nn++){
       for(int m=0;m<nbeads1; m++){
		   if(m==0 || m==nbeads1-1) writeW << cc1 << " " << nn+1 << " " << 2 << " " << position[nn][m][0]<<" " << position[nn][m][1] << " " << position[nn][m][2] << " " << 0 << " " << 0 << " " << 0 << endl;
		   else writeW << cc1 << " " << nn+1 << " " << 1 << " " << position[nn][m][0]<<" " << position[nn][m][1] << " " << position[nn][m][2] << " " << 0 << " " << 0 << " " << 0 << endl;
		   cc1++;
	   }
	}
	for(int nn=0; nn<npoly2; nn++){
		for(int m=0;m<nbeads2; m++){
			if(m==0 || m==nbeads2-1)  writeW << cc1 << " " << nn+1+npoly1 << " " << 2 << " " << position[nn][m][0]<<" " << position[nn][m][1] << " " << position[nn][m][2] << " " << 0 << " " << 0 << " " << 0 << endl;
			else  writeW << cc1 << " " << nn+1+npoly1 << " " << 3 << " " << position[nn][m][0]<<" " << position[nn][m][1] << " " << position[nn][m][2] << " " << 0 << " " << 0 << " " << 0 << endl;
			cc1++;
		}
	}

///////////////////////////////////////////////////////////
//FINISHED POLYMERS 1 AND 2
///////////////////////////////////////////////////////////

writeW << endl;
writeW << endl;

	writeW << "\n Velocities \n" <<endl;
for(int i=0;i<totb; i++) writeW<<i+1 << " "<<0 << " "<<0<<" "<<0 <<endl;
writeW << endl;

	writeW << "\n Bonds \n"<<endl;
for(int i=0;i<nbond;i++) {
writeW << i+1 <<" "<< 1 <<" "<< bond[i][0]+1<<" "<<bond[i][1]+1 << endl;
}

writeW << "\n Angles \n"<<endl; 
for(int i=0;i<nangle;i++) writeW << i+1 <<" "<< 1 <<" "<< angle[i][0]+1<<" "<<angle[i][1]+1 <<" "<< angle[i][2]+1<< endl;
///////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////

writeW.close();

return 0;
}

